package com.chinaitop.depot.basic.model;

import java.math.BigDecimal;
import java.util.Date;

public class BasicTank {
    private Integer id;

    private String storagetankCode;

    private String storagetankName;

    private String orgCode;

    private BigDecimal tankCapacity;

    private Date createdate;

    private Integer facilitiesType;

    private Integer heatingType;

    private Integer tankType;

    private BigDecimal diameter;

    private BigDecimal height;
    
    private Date builddate;

    private Integer checkWay;

    private Integer weldWay;

    private Integer tankApply;

    private Integer tankStatus;

    private Integer orgId;

    private Integer delFlag;

    private Date updatetime;
    
    private String crkStatus;

    private String ygdm;

    private String ygajdm;

    /**
     * 油罐id
     * @return id 油罐id
     */
    public Integer getId() {
        return id;
    }

    /**
     * 油罐id
     * @param id 油罐id
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 油罐编码
     * @return storageTank_code 油罐编码
     */
    public String getStoragetankCode() {
        return storagetankCode;
    }

    /**
     * 油罐编码
     * @param storagetankCode 油罐编码
     */
    public void setStoragetankCode(String storagetankCode) {
        this.storagetankCode = storagetankCode == null ? null : storagetankCode.trim();
    }

    /**
     * 油罐名称
     * @return storageTank_name 油罐名称
     */
    public String getStoragetankName() {
        return storagetankName;
    }

    /**
     * 油罐名称
     * @param storagetankName 油罐名称
     */
    public void setStoragetankName(String storagetankName) {
        this.storagetankName = storagetankName == null ? null : storagetankName.trim();
    }

    /**
     * 库区编码
     * @return org_code 库区编码
     */
    public String getOrgCode() {
        return orgCode;
    }

    /**
     * 库区编码
     * @param orgCode 库区编码
     */
    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode == null ? null : orgCode.trim();
    }

    /**
     * 油罐容量(吨)
     * @return tank_capacity 油罐容量(吨)
     */
    public BigDecimal getTankCapacity() {
        return tankCapacity;
    }

    /**
     * 油罐容量(吨)
     * @param tankCapacity 油罐容量(吨)
     */
    public void setTankCapacity(BigDecimal tankCapacity) {
        this.tankCapacity = tankCapacity;
    }

    /**
     * 创建日期
     * @return createDate 创建日期
     */
    public Date getCreatedate() {
        return createdate;
    }

    /**
     * 创建日期
     * @param createdate 创建日期
     */
    public void setCreatedate(Date createdate) {
        this.createdate = createdate;
    }

    /**
     * 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     * @return facilities_type 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     */
    public Integer getFacilitiesType() {
        return facilitiesType;
    }

    /**
     * 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     * @param facilitiesType 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     */
    public void setFacilitiesType(Integer facilitiesType) {
        this.facilitiesType = facilitiesType;
    }

    /**
     * 有无加热装置(1：有,0：无,9:其他或不确定)
     * @return heating_type 有无加热装置(1：有,0：无,9:其他或不确定)
     */
    public Integer getHeatingType() {
        return heatingType;
    }

    /**
     * 有无加热装置(1：有,0：无,9:其他或不确定)
     * @param heatingType 有无加热装置(1：有,0：无,9:其他或不确定)
     */
    public void setHeatingType(Integer heatingType) {
        this.heatingType = heatingType;
    }

    /**
     * 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     * @return tank_type 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     */
    public Integer getTankType() {
        return tankType;
    }

    /**
     * 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     * @param tankType 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     */
    public void setTankType(Integer tankType) {
        this.tankType = tankType;
    }

    /**
     * 直径
     * @return diameter 直径
     */
    public BigDecimal getDiameter() {
        return diameter;
    }

    /**
     * 直径
     * @param diameter 直径
     */
    public void setDiameter(BigDecimal diameter) {
        this.diameter = diameter;
    }

    /**
     * 高度
     * @return height 高度
     */
    public BigDecimal getHeight() {
        return height;
    }

    /**
     * 高度
     * @param height 高度
     */
    public void setHeight(BigDecimal height) {
        this.height = height;
    }
    
    public Date getBuilddate() {
		return builddate;
	}

	public void setBuilddate(Date builddate) {
		this.builddate = builddate;
	}

	/**
     * 检定方式(1：标定,0：非标定,9:其他或不确定)
     * @return check_way 检定方式(1：标定,0：非标定,9:其他或不确定)
     */
    public Integer getCheckWay() {
        return checkWay;
    }

    /**
     * 检定方式(1：标定,0：非标定,9:其他或不确定)
     * @param checkWay 检定方式(1：标定,0：非标定,9:其他或不确定)
     */
    public void setCheckWay(Integer checkWay) {
        this.checkWay = checkWay;
    }

    /**
     * 焊接方式(1：对接,2：搭接,9:其他或不确定)
     * @return weld_way 焊接方式(1：对接,2：搭接,9:其他或不确定)
     */
    public Integer getWeldWay() {
        return weldWay;
    }

    /**
     * 焊接方式(1：对接,2：搭接,9:其他或不确定)
     * @param weldWay 焊接方式(1：对接,2：搭接,9:其他或不确定)
     */
    public void setWeldWay(Integer weldWay) {
        this.weldWay = weldWay;
    }

    /**
     * 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     * @return tank_apply 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     */
    public Integer getTankApply() {
        return tankApply;
    }

    /**
     * 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     * @param tankApply 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     */
    public void setTankApply(Integer tankApply) {
        this.tankApply = tankApply;
    }

    /**
     * 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     * @return tank_status 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     */
    public Integer getTankStatus() {
        return tankStatus;
    }

    /**
     * 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     * @param tankStatus 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     */
    public void setTankStatus(Integer tankStatus) {
        this.tankStatus = tankStatus;
    }

    /**
     * 库级id
     * @return org_id 库级id
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 库级id
     * @param orgId 库级id
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 删除状态(1.正常，2.删除)
     * @return del_flag 删除状态(1.正常，2.删除)
     */
    public Integer getDelFlag() {
        return delFlag;
    }

    /**
     * 删除状态(1.正常，2.删除)
     * @param delFlag 删除状态(1.正常，2.删除)
     */
    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    /**
     * 
     * @return updatetime 
     */
    public Date getUpdatetime() {
        return updatetime;
    }

    /**
     * 
     * @param updatetime 
     */
    public void setUpdatetime(Date updatetime) {
        this.updatetime = updatetime;
    }

	public String getCrkStatus() {
		return crkStatus;
	}

	public void setCrkStatus(String crkStatus) {
		this.crkStatus = crkStatus;
	}

	public String getYgdm() {
		return ygdm;
	}

	public void setYgdm(String ygdm) {
		this.ygdm = ygdm;
	}

	public String getYgajdm() {
		return ygajdm;
	}

	public void setYgajdm(String ygajdm) {
		this.ygajdm = ygajdm;
	}

}