package com.chinaitop.depot.basic.model;

import java.math.BigDecimal;
import java.util.Date;

public class BasicWarehouse {
    private Integer warehouseId;

    private Integer depotId;

    private String depotName;

    private Integer storehouseId;

    private String warehouseCode;

    private String warehouseName;

    private Date warehouseUseTime;

    private Integer warehouseStatus;

    private Integer storeWay;

    private BigDecimal length;

    private BigDecimal width;

    private BigDecimal heigth;

    private String contactNumber;

    private BigDecimal warehouseCapacity;

    private String dutystoreman;

    private String remark;

    private String wareImg;

    private String createname;

    private String updatename;

    private Date createdate;

    private Date updatedate;

    private Integer delFlag;

    private Integer orgId;

    private String libraryType;

    private Date updatetime;

    private String crkStatus;

    private String hwdm;

    /**
     * 货位ID
     * @return warehouse_id 货位ID
     */
    public Integer getWarehouseId() {
        return warehouseId;
    }

    /**
     * 货位ID
     * @param warehouseId 货位ID
     */
    public void setWarehouseId(Integer warehouseId) {
        this.warehouseId = warehouseId;
    }

    /**
     * 所属粮库ID
     * @return depot_id 所属粮库ID
     */
    public Integer getDepotId() {
        return depotId;
    }

    /**
     * 所属粮库ID
     * @param depotId 所属粮库ID
     */
    public void setDepotId(Integer depotId) {
        this.depotId = depotId;
    }

    /**
     * 所属粮库名称
     * @return depot_name 所属粮库名称
     */
    public String getDepotName() {
        return depotName;
    }

    /**
     * 所属粮库名称
     * @param depotName 所属粮库名称
     */
    public void setDepotName(String depotName) {
        this.depotName = depotName == null ? null : depotName.trim();
    }

    /**
     * 仓房ID
     * @return storehouse_id 仓房ID
     */
    public Integer getStorehouseId() {
        return storehouseId;
    }

    /**
     * 仓房ID
     * @param storehouseId 仓房ID
     */
    public void setStorehouseId(Integer storehouseId) {
        this.storehouseId = storehouseId;
    }

    /**
     * 货位编码
     * @return warehouse_code 货位编码
     */
    public String getWarehouseCode() {
        return warehouseCode;
    }

    /**
     * 货位编码
     * @param warehouseCode 货位编码
     */
    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode == null ? null : warehouseCode.trim();
    }

    /**
     * 货位名称
     * @return warehouse_name 货位名称
     */
    public String getWarehouseName() {
        return warehouseName;
    }

    /**
     * 货位名称
     * @param warehouseName 货位名称
     */
    public void setWarehouseName(String warehouseName) {
        this.warehouseName = warehouseName == null ? null : warehouseName.trim();
    }

    /**
     * 货位启用日期
     * @return warehouse_use_time 货位启用日期
     */
    public Date getWarehouseUseTime() {
        return warehouseUseTime;
    }

    /**
     * 货位启用日期
     * @param warehouseUseTime 货位启用日期
     */
    public void setWarehouseUseTime(Date warehouseUseTime) {
        this.warehouseUseTime = warehouseUseTime;
    }

    /**
     * 货位状态
     * @return warehouse_status 货位状态
     */
    public Integer getWarehouseStatus() {
        return warehouseStatus;
    }

    /**
     * 货位状态
     * @param warehouseStatus 货位状态
     */
    public void setWarehouseStatus(Integer warehouseStatus) {
        this.warehouseStatus = warehouseStatus;
    }

    /**
     * 储粮方式
     * @return store_way 储粮方式
     */
    public Integer getStoreWay() {
        return storeWay;
    }

    /**
     * 储粮方式
     * @param storeWay 储粮方式
     */
    public void setStoreWay(Integer storeWay) {
        this.storeWay = storeWay;
    }

    /**
     * 长度（米）
     * @return length 长度（米）
     */
    public BigDecimal getLength() {
        return length;
    }

    /**
     * 长度（米）
     * @param length 长度（米）
     */
    public void setLength(BigDecimal length) {
        this.length = length;
    }

    /**
     * 宽度（米）
     * @return width 宽度（米）
     */
    public BigDecimal getWidth() {
        return width;
    }

    /**
     * 宽度（米）
     * @param width 宽度（米）
     */
    public void setWidth(BigDecimal width) {
        this.width = width;
    }

    /**
     * 高度（米）
     * @return heigth 高度（米）
     */
    public BigDecimal getHeigth() {
        return heigth;
    }

    /**
     * 高度（米）
     * @param heigth 高度（米）
     */
    public void setHeigth(BigDecimal heigth) {
        this.heigth = heigth;
    }

    /**
     * 联系电话
     * @return contact_number 联系电话
     */
    public String getContactNumber() {
        return contactNumber;
    }

    /**
     * 联系电话
     * @param contactNumber 联系电话
     */
    public void setContactNumber(String contactNumber) {
        this.contactNumber = contactNumber == null ? null : contactNumber.trim();
    }

    /**
     * 货位容量（数字，单位吨）
     * @return warehouse_capacity 货位容量（数字，单位吨）
     */
    public BigDecimal getWarehouseCapacity() {
        return warehouseCapacity;
    }

    /**
     * 货位容量（数字，单位吨）
     * @param warehouseCapacity 货位容量（数字，单位吨）
     */
    public void setWarehouseCapacity(BigDecimal warehouseCapacity) {
        this.warehouseCapacity = warehouseCapacity;
    }

    /**
     * 责任保管员
     * @return dutyStoreman 责任保管员
     */
    public String getDutystoreman() {
        return dutystoreman;
    }

    /**
     * 责任保管员
     * @param dutystoreman 责任保管员
     */
    public void setDutystoreman(String dutystoreman) {
        this.dutystoreman = dutystoreman == null ? null : dutystoreman.trim();
    }

    /**
     * 备注
     * @return remark 备注
     */
    public String getRemark() {
        return remark;
    }

    /**
     * 备注
     * @param remark 备注
     */
    public void setRemark(String remark) {
        this.remark = remark == null ? null : remark.trim();
    }

    /**
     * 货位图
     * @return ware_img 货位图
     */
    public String getWareImg() {
        return wareImg;
    }

    /**
     * 货位图
     * @param wareImg 货位图
     */
    public void setWareImg(String wareImg) {
        this.wareImg = wareImg == null ? null : wareImg.trim();
    }

    /**
     * 创建人
     * @return createName 创建人
     */
    public String getCreatename() {
        return createname;
    }

    /**
     * 创建人
     * @param createname 创建人
     */
    public void setCreatename(String createname) {
        this.createname = createname == null ? null : createname.trim();
    }

    /**
     * 更新人
     * @return updateName 更新人
     */
    public String getUpdatename() {
        return updatename;
    }

    /**
     * 更新人
     * @param updatename 更新人
     */
    public void setUpdatename(String updatename) {
        this.updatename = updatename == null ? null : updatename.trim();
    }

    /**
     * 创建日期
     * @return createDate 创建日期
     */
    public Date getCreatedate() {
        return createdate;
    }

    /**
     * 创建日期
     * @param createdate 创建日期
     */
    public void setCreatedate(Date createdate) {
        this.createdate = createdate;
    }

    /**
     * 更新日期
     * @return updateDate 更新日期
     */
    public Date getUpdatedate() {
        return updatedate;
    }

    /**
     * 更新日期
     * @param updatedate 更新日期
     */
    public void setUpdatedate(Date updatedate) {
        this.updatedate = updatedate;
    }

    /**
     * 删除状态(1.正常，2.删除)
     * @return del_flag 删除状态(1.正常，2.删除)
     */
    public Integer getDelFlag() {
        return delFlag;
    }

    /**
     * 删除状态(1.正常，2.删除)
     * @param delFlag 删除状态(1.正常，2.删除)
     */
    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    /**
     * 
     * @return org_id 
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 
     * @param orgId 
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 库类型，0.主粮库，1.代储点粮库
     * @return library_type 库类型，0.主粮库，1.代储点粮库
     */
    public String getLibraryType() {
        return libraryType;
    }

    /**
     * 库类型，0.主粮库，1.代储点粮库
     * @param libraryType 库类型，0.主粮库，1.代储点粮库
     */
    public void setLibraryType(String libraryType) {
        this.libraryType = libraryType == null ? null : libraryType.trim();
    }

    /**
     * 
     * @return updatetime 
     */
    public Date getUpdatetime() {
        return updatetime;
    }

    /**
     * 
     * @param updatetime 
     */
    public void setUpdatetime(Date updatetime) {
        this.updatetime = updatetime;
    }

    /**
     * 出入库状态(1空仓,2入库中,3封仓,4出库中,9其它)
     * @return crk_status 出入库状态(1空仓,2入库中,3封仓,4出库中,9其它)
     */
    public String getCrkStatus() {
        return crkStatus;
    }

    /**
     * 出入库状态(1空仓,2入库中,3封仓,4出库中,9其它)
     * @param crkStatus 出入库状态(1空仓,2入库中,3封仓,4出库中,9其它)
     */
    public void setCrkStatus(String crkStatus) {
        this.crkStatus = crkStatus == null ? null : crkStatus.trim();
    }

	public String getHwdm() {
		return hwdm;
	}

	public void setHwdm(String hwdm) {
		this.hwdm = hwdm;
	}
}