package com.chinaitop.depot.basic.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicStorehouse;
import com.chinaitop.depot.basic.model.BasicWarehouse;
import com.chinaitop.depot.basic.model.BasicWarehouseExample;

public interface BasicWarehouseService {

	/**
	 * 新增
	 * @param basicWarehouse
	 */
	void add(BasicWarehouse basicWarehouse);
	
	/**
	 * 修改
	 * @param basicWarehouse
	 */
	void update(BasicWarehouse basicWarehouse);
	
	/**
	 * 删除
	 * @param id
	 */
	void delete(Integer id);
	
	/**
	 * 按ID查询一条数据
	 * @param id
	 * @return
	 */
	BasicWarehouse findByParmaryKey(Integer id);
	
	/**
	 * 按条件查询一组数据
	 * @param example
	 * @return
	 */
	List<BasicWarehouse> findCondition(BasicWarehouseExample example);
	
	/**
	 * 货位信息对外接口
	 * @param unitId 单位ID
	 * @param storehouseId 仓房ID
	 * @param libraryType库类型(0主粮库,1代储库)
	 * @return
	 */
	Map<String, Object> getWarehouse(Integer unitId, Integer storehouseId, String libraryType);

	/**
	 * 按仓房ID删除货位数据
	 * 
	 * @param storehouseId 仓房ID
	 */
	void deletEexample(Integer storehouseId);

	/**
	 * 查询当前单位下货位总数
	 * 
	 * @param orgId 单位ID
	 * @param delFlag 启用状态(1:启用,0:弃用)
	 * @return
	 * @throws Exception
	 */
	Integer getCountWhs(Integer orgId, Integer delFlag) throws Exception;

	/**
	 * 更新货位数据
	 * 
	 * @param basicStorehouse
	 * @param warehouseJson
	 */
	void saveOrUpdate(BasicStorehouse basicStorehouse, String warehouseJson) throws Exception;

}
