package com.chinaitop.depot.basic.service.impl;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.mapper.BasicEnumMapper;
import com.chinaitop.depot.basic.mapper.BasicTankHwMapper;
import com.chinaitop.depot.basic.mapper.BasicTankMapper;
import com.chinaitop.depot.basic.model.BasicEnum;
import com.chinaitop.depot.basic.model.BasicEnumExample;
import com.chinaitop.depot.basic.model.BasicTank;
import com.chinaitop.depot.basic.model.BasicTankExample;
import com.chinaitop.depot.basic.model.BasicTankHw;
import com.chinaitop.depot.basic.service.BasicStorehouseService;
import com.chinaitop.depot.basic.service.BasicTankService;
import com.chinaitop.depot.utils.BusinessUtils;
import com.chinaitop.utils.ParameterUtil;
import com.fasterxml.jackson.databind.ObjectMapper;

@Service
public class BasicTankServiceImpl implements BasicTankService {

	@Resource
	private BasicTankMapper basicTankMapper;

	@Resource
	private BasicStorehouseService basicStorehouseService;

	@Resource
	private BasicEnumMapper enumMapper;

	@Resource
	private BasicTankHwMapper basicTankHwMapper;


	@Override
	public List<BasicTank> findBasicTank(BasicTankExample example) {

		List<BasicTank> basicTanks = basicTankMapper.selectByExample(example);

		return basicTanks;
	}

	@Override
    public void saveOrEdit(HttpServletRequest request, BasicTank basicTank,Integer orgId) {
		basicTank.setDelFlag(1);
		basicTank.setOrgId(orgId);

		//组装油罐货位
		String org_obj = ObjectUtils.toString(request.getSession().getAttribute("orgInfo"),"");
		String bgdw = null;
		String dwdm = ""; //18位统一信用代码
		if(!org_obj.isEmpty()) {
			JSONObject obj = JSONObject.parseObject(org_obj);
			bgdw = ObjectUtils.toString(obj.get("orgName"), "");//保管单位默认为当前用户所在的单位
			dwdm = ObjectUtils.toString(obj.get("creditCode"), "");
		}
		BasicTankHw tankhw = new BasicTankHw();
		tankhw.setOrgId(orgId);
		tankhw.setHwbm("01");
		tankhw.setHwmc(basicTank.getStoragetankName());
		tankhw.setHwqyrq(basicTank.getBuilddate());
		tankhw.setHwrl(basicTank.getTankCapacity());
		tankhw.setBgdw(bgdw);
		tankhw.setCzbz("i");
		tankhw.setZhgxsj(basicTank.getCreatedate());
		tankhw.setCrkStatus(basicTank.getCrkStatus());

		String ygbm = "";//油罐编码
		String ajbm = "";//廒间编码

		if (!"".equals(basicTank.getStoragetankCode())) {
			ygbm = BusinessUtils.setBZcfandygbm(dwdm, basicTank.getStoragetankCode(), "1", orgId+"");
			ajbm = BusinessUtils.setBZajbm(ygbm, "", "1");
			basicTank.setYgdm(ygbm);
			basicTank.setYgajdm(ajbm);
		}
        if(basicTank.getId()==null){
			basicTankMapper.insertSelective(basicTank);

			tankhw.setId(basicTank.getId());
			tankhw.setHwbm(BusinessUtils.setBZhwbm(basicTank.getYgajdm(), "01"));
			basicTankHwMapper.insertSelective(tankhw);
		}else{
			if (!"".equals(basicTank.getStoragetankCode())) {
				tankhw.setHwbm(BusinessUtils.setBZhwbm(basicTank.getYgajdm(), "01"));
			}
			tankhw.setId(basicTank.getId());
			basicTankMapper.updateByPrimaryKeySelective(basicTank);
			basicTankHwMapper.updateByPrimaryKeySelective(tankhw);
		}


//        BasicTank basicTank_n = basicTankMapper.selectByPrimaryKey(basicTank.getId());
//        if (null != basicTank_n) {
//        	basicTankHwMapper.updateByPrimaryKeySelective(tankhw);
//        } else {
//        	basicTankHwMapper.insertSelective(tankhw);
//        }
    }

    @Override
    public BasicTank findByPrimary(Integer id) {
        return basicTankMapper.selectByPrimaryKey(id);
    }

	@Override
	public void updateBasicTank(Integer id, Integer delFlag) throws Exception {

		BasicTank basicTank = basicTankMapper.selectByPrimaryKey(id);
		// 启用 ： 1
		// 弃用 ： 0  当前是启用，则改成0，如果当前是弃用,则改成1
		if (delFlag == 1) {
			delFlag = 0;
		} else if (delFlag == 0) {
			delFlag = 1;
		}
		basicTank.setDelFlag(delFlag);
		basicTankMapper.updateByPrimaryKeySelective(basicTank);
		/* 更新油罐数量 */
		basicStorehouseService.editOrgChNum(basicTank.getOrgId());
	}

	@Override
	public Boolean findStorageTankCodeList(BasicTankExample basicTankExample, Integer id) {
		List<BasicTank>  basicTankList = basicTankMapper.selectByExample(basicTankExample);
		try {
			if(null != basicTankList && !basicTankList.isEmpty() ){
				if(id != null){
					//id有值是修改
					BasicTank basicTank = basicTankMapper.selectByPrimaryKey(id);

					if(null != basicTank && basicTank.getStoragetankCode().equals(basicTankList.get(0).getStoragetankCode()) && basicTankList.size() > 1 ){
						return true;
					}else if (basicTankList.size() > 0){
						return true;
					}
				}else{
					if (basicTankList.size() > 0) {
						return true;
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

    @Override
    public String importData(List<List<String>> list, JSONObject user,String orgCode) {
		Integer orgId = null;
		if (null != user) {
			orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
		}

		Map<String, Integer> map = new HashMap<String, Integer>();
		BasicTank tank = null;
		String msg = "";//消息
		boolean value_flag = false;
		int len = 0;//长度
		//根据字典名字查询字典编号
		BasicEnumExample enumExample = new BasicEnumExample();
		BasicEnumExample.Criteria Criteria = enumExample.createCriteria();
		List<BasicEnum> basicEnums;

		BasicTankExample basicTankExample = new BasicTankExample();
		BasicTankExample.Criteria criteria = basicTankExample.createCriteria();
		List<BasicTank>  basicTankList;

		for (int i = 0; i < list.size(); i++) {
			List<String> revList = list.get(i);

			for (int j = 0; j < revList.size(); j++) {
				switch(j) {
					case 0://油罐编码
						if (ParameterUtil.isnotnull(revList.get(j))) {
							len = revList.get(j).length();
							if (len > 50) {
								msg = "第 "+(i+1)+" 行第 1 列的值的长度不能超过50！";
								return msg;
							}

							if (null != revList.get(j)) {
								criteria.andStoragetankCodeEqualTo(revList.get(j));
							}
							basicTankList = basicTankMapper.selectByExample(basicTankExample);

							if (basicTankList.size() > 0) {
								msg = "第 "+(i+1)+" 行 油罐编码重复";
								return msg;
							}

							Integer mapKey = map.get(revList.get(j));
							if (mapKey == null) {
								tank = new BasicTank();
								map.put(revList.get(j), null);
								tank.setStoragetankCode(revList.get(j));
							}
						}
						break;
					case 1://油罐名称
						if (tank != null) {
							len = revList.get(j).length();
							if (len > 50) {
								msg = "第 "+(i+1)+" 行第 2 列的值的长度不能超过50！";
								return msg;
							}
							tank.setStoragetankName(revList.get(j));
						}
						break;
					case 2://库区编码
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							len = revList.get(j).length();
							if (len > 50) {
								msg = "第 "+(i+1)+" 行第 3 列的值的长度不能超过50！";
								return msg;
							}
							tank.setOrgCode(orgCode);
						}
						break;
					case 3://油罐容量(吨)
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							value_flag = revList.get(j).matches("[0-9]+");
							if (!value_flag) {
								msg = "第 "+(i+1)+" 行的第 4 列的值只能是数字！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行第 4 列的值的长度不能超过30！";
								return msg;
							}
							tank.setTankCapacity(BigDecimal.valueOf(Integer.parseInt(revList.get(j))));
						}
						break;
					case 4://设施是否完好
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 5 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过100！";
								return msg;
							}
							tank.setFacilitiesType(basicEnums.get(0).getEnumid());
						}
						break;
					case 5://有无加热装置
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 6 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 6 列的值的长度不能超过100！";
								return msg;
							}
							tank.setHeatingType(basicEnums.get(0).getEnumid());
						}
						break;
					case 6://油罐类型
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 7 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 7 列的值的长度不能超过100！";
								return msg;
							}
							tank.setTankType(basicEnums.get(0).getEnumid());
						}
						break;
					case 7://直径
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							value_flag = revList.get(j).matches("[0-9]+");
							if (!value_flag) {
								msg = "第 "+(i+1)+" 行的第 8 列的值只能是数字！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行第 8 列的值的长度不能超过30！";
								return msg;
							}
							BigDecimal bg = new BigDecimal(revList.get(j).toString());
							tank.setDiameter(bg);
						}
						break;
					case 8://高度
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							value_flag = revList.get(j).matches("[0-9]+");
							if (!value_flag) {
								msg = "第 "+(i+1)+" 行的第 9 列的值只能是数字！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行第 9 列的值的长度不能超过30！";
								return msg;
							}
							BigDecimal bg = new BigDecimal(revList.get(j).toString());
							tank.setHeight(bg);
						}
						break;
					case 9://检定方式
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 10 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 10 列的值的长度不能超过100！";
								return msg;
							}
							tank.setCheckWay(basicEnums.get(0).getEnumid());
						}
						break;
					case 10://焊接方式
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 12 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 12 列的值的长度不能超过100！";
								return msg;
							}
							tank.setWeldWay(basicEnums.get(0).getEnumid());
						}
						break;
					case 11://油罐使用情况
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 13 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 13 列的值的长度不能超过100！";
								return msg;
							}
							tank.setTankApply(basicEnums.get(0).getEnumid());
						}
						break;
					case 12://油罐状态
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							enumExample.clear();
							Criteria = enumExample.createCriteria();
							Criteria.andEnumnameEqualTo(revList.get(j));
							basicEnums = enumMapper.selectByExample(enumExample);
							if(basicEnums.size() == 0){
								msg = "第 "+(i+1)+" 行第 14 列的值不正确，请查找后在导入！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 100) {
								msg = "第 "+(i+1)+" 行第 14 列的值的长度不能超过100！";
								return msg;
							}
							tank.setTankStatus(basicEnums.get(0).getEnumid());
						}
						break;
					case 13://交付使用日期
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							if(!ParameterUtil.stringIsTime(revList.get(j))){
								msg = "第 "+(i+1)+" 行第 15 列的值不属于时间，请确认后再提交！";
								return msg;
							}
							tank.setCreatedate(ParameterUtil.string2datetime(revList.get(j)));
						}
						if (tank != null) {
							tank.setDelFlag(1);
							tank.setOrgId(orgId);
							basicTankMapper.insertSelective(tank);
						}
						break;
					default :
						break;
				}

			}

		}
		return msg;
    }

	@Override
	public Map<String, Object> updateOrSave(HttpServletRequest request, String tankJson, Integer orgId) throws Exception {
		Map<String, Object> modelMap = new HashMap<String, Object>();

		// JSON字符串转对象
		ObjectMapper mapper = new ObjectMapper();
		BasicTank basicTank = mapper.readValue(tankJson, BasicTank.class);

		// 校验编码是否重复
		BasicTankExample example = new BasicTankExample();
		BasicTankExample.Criteria criteria = example.createCriteria();
		criteria.andOrgIdEqualTo(orgId);
		criteria.andStoragetankCodeEqualTo(basicTank.getStoragetankCode());
		List<BasicTank> list = null;
		if (null != basicTank.getId() && !"".equals(basicTank.getId())) {//修改
			criteria.andIdNotEqualTo(basicTank.getId());

			// 查询除当前数据外还要别的油罐编码跟当前录入的编码一样，一样就是有重复的，没有就可以录入
			list = basicTankMapper.selectByExample(example);
			if (null != list && list.size() > 0) {
				// 获取自己数据的ID
				modelMap.put("status", "error");
				modelMap.put("msg", "油罐编码已存在，不可与其它油罐编码重复！");
				return modelMap;
			}
		} else {//新增
			list = basicTankMapper.selectByExample(example);
			if (null != list && list.size() > 0) {
				modelMap.put("status", "error");
				modelMap.put("msg", "油罐编码已存在，不可与其它油罐编码重复！");
				return modelMap;
			}
		}

		//更新油罐信息
		this.saveOrEdit(request, basicTank, orgId);
		
		//更新单位表中仓房数、油罐数、有效仓容、有效罐容
		basicStorehouseService.editOrgChNum(orgId);

		modelMap.put("status", "success");
		modelMap.put("msg", "保存成功！");

        return modelMap;
	}
}
